
' Easy-Door V2.0b Automatic Multi-BBS detection
' ---------------------------------------------

' Depending on the filename, the corresponding BBS type is used.
' Please read the DoorDef.BI to see the supported BBS type.


Ok = 0                          ' Succes flag when reading DOOR file

FileName$ = UCASE$(COMMAND$)

IF FileName$ = "" THEN
        FullName$ = "Unknown"
        Location$ = "Nowhere"
        Baud$ = ""
        Com$ = "0"
        AnsiFlag$ = "1"
        TimeRemaining$ = "180"
ELSE
        CALL Exist(FileName$ + CHR$(0), Ex)

        IF Ex THEN
       
                IF INSTR(FileName$, "DORINFO") THEN BBSType = 1
                IF FileName$ = "DOOR.SYS" THEN BBSType = 2
                IF INSTR(FileName$, "CALLINF") THEN BBSType = 4
                IF FileName$ = "INFO.BBS" THEN BBSType = 3
                IF INSTR(FileName$, "SF") THEN BBSType = 5
                IF FileName$ = "CHAIN.TXT" THEN BBSType = 6
                ReadDoorFile FileName$, BBSType, FullName$, Location$, Baud$, Com$, AnsiFlag$, TimeRemaining$
        ELSE
                CLS
                PRINT
                PRINT "ERROR: "; FileName$; " not found or BBS type not recognized"
                PRINT
                END
        END IF

END IF

