program DEMO_PROGRAM_Output_01;
{ Demonstrations Of Some Input/Output Routines }
{ (C)opyright 1991, Cyber-Dyne Software. All Rights Reserved! }

Uses Crt, Dos, basFAST;

var
  Window : WindowOBJ;
  Count : byte;

begin
  with Screen do begin
    Init; { Initialize The ScreenOBJ Object }
    ClearScreen( ColorAttr( Black, Blue ), ' ' ); { Clear The Screen }
    with Window do begin
      Init; { Initialize The WindowOBJ Object }
      ShadowExplodeBox( 5, 2, 76, 7, ColorAttr( Black, Cyan ), 2 );
    end; { LOOP: Window }
    SetColors( ColorAttr( White, Cyan ), ColorAttr( Black, Cyan ));
    WriteCenter( 3, ColorAttr( White, Cyan ), 'The Basner Utilities v1.0a For Turbo Pascal v6.0' );
    WriteCenter( 4, ColorAttr( White, Cyan ), '(C)opyright 1991, Cyber-Dyne Software. All Rights Reserved.' );
    WriteCenter( 6, ColorAttr( Blue, Cyan ), 'PROGRAM: BDEMOUT1 - ~Demonstrations Of Output Routines.~' );
    with Window do begin
      FillBox( 2, 15, 79, 24, ColorAttr( Black, Red ), 3 );
    end; { LOOP: Window }
    SetColors( ColorAttr( Yellow, Red ), ColorAttr( White, Red ));
    WriteAt( 19, 16, ColorAttr( Yellow, Red ), 'This Is ~WRITEAT( 19, 16, {COLOR}, {TEXT} )~' );
    WriteCenter( 17, ColorAttr( Yellow, Red ), 'This Is ~WRITECENTER( 17, {COLOR}, {TEXT} )~' );
    WriteBetween( 3, 78, 18, ColorAttr( Yellow, Red ), 'This Is ~WRITEBETWEEN( 3, 78, 18, {COLOR}, {TEXT} )~' );
    WritePlain( 24, 19, 'This Is ~WRITEPLAIN( 24, 19, {TEXT} )~' );
    WriteBack( 18, 20, ColorAttr( Yellow, Red ), 'This Is ~WRITEBACK( 18, 20, {COLOR}, {TEXT} )~' );
    with Window do begin
      ShadowBox( 2, 2, 6, 18, ColorAttr( Black, Red ), 2 );
    end; { LOOP: Window }
    WriteVertical( 4, 4, ColorAttr( White, Red ), 'WRITEVERTICAL' );
    SaveScreen( 1 ); { Save Current Screen Into Element 1 }
    with Window do begin
      ShadowExplodeBox( 5, 5, 76, 15, ColorAttr( Black, Cyan ), 2 );
      WriteCenter( 6, ColorAttr( White, Cyan ), ' * Now For Some FANCY Window Routines! * ' );
      delay( 2000 );
      ClearScreen( ColorAttr( White, Black ), ' ' );
      Box( 3, 2, 78, 24, ColorAttr( Black, Cyan ), 1 );
      WriteCenter( 4, ColorAttr( White, Black ), 'BOX( 3, 2, 78, 24, ColorAttrr( White, Cyan ), 1 )' );
      WriteCenter( 5, ColorAttr( Yellow, Black ), 'Type 1 - No Border Character' );
      SaveScreen( 2 );
      delay( 2000 );
      FillBox( 5, 3, 76, 23, ColorAttr( Black, Red ), 2 );
      WriteCenter( 5, ColorAttr( Yellow, Red ), 'FILLBOX( 5, 3, 76, 23, ColorAttr( Black, Red ), 2 )' );
      WriteCenter( 6, ColorAttr( White, Red ), 'Type 2 - Single Line Box' );
      SaveScreen( 3 );
      delay( 2000 );
      ShadowBox( 7, 4, 74, 22, ColorAttr( LightBlue, Blue ), 3 );
      WriteCenter( 6, ColorAttr( Yellow, Blue ), 'SHADOWBOX( 7, 4, 74, 22, ColorAttr( LightBlue, Blue ), 3 )' );
      WriteCenter( 7, ColorAttr( White, Blue ), 'Type 3 - Double Line Box' );
      SaveScreen( 4 );
      delay( 2000 );
      ExplodeBox( 9, 5, 72, 21, ColorAttr( Black, Green ), 4 );
      WriteCenter( 7, ColorAttr( White, Green ), 'EXPLODEBOX( 9, 5, 72, 21, ColorAttr( Black, Green ), 5 )' );
      WriteCenter( 8, ColorAttr( Yellow, Green ), 'Type 4 - Double Line Vertical, Single Line Horizontal' );
      SaveScreen( 5 );
      delay( 2000 );
      ShadowExplodeBox( 8, 6, 73, 12, ColorAttr( Black, Red ), 5 );
      WriteCenter( 8, ColorAttr( White, Red ), 'SHADOWEXPLODEBOX( 8, 6, 76, 12, ColorAttr( Black, Red ), 5 )' );
      WriteCenter( 9, ColorAttr( Yellow, Red ), 'Type 5 - Single Line Vertical, Double Line Horizontal' );
      delay( 2000 );
      for Count := 5 downto 2 do begin
        WriteCenter( Count+6, ColorAttr( Yellow, Black ), ' Now Restoring Previous Window! ' );
        delay( 2000 );
        RestoreScreen( Count );
      end; { LOOP: Count }
      WriteCenter( 7, ColorAttr( Yellow, Black ), 'Now Restoring The Original Screen!' );
      delay( 2000 );
      RestoreScreen( 1 );
    end; { LOOP: Window }
  end; { LOOP: Screen }
  delay( 2000 ); { Let The User See How Nice This Program Is! :-) }
end. { PROGRAM: DEMO_PROGRAM_Output_01 }