Program demo;

USES 
   FastTTT5,                   { Fast screen writing }
   IoTTT5,                     { Input Routines }
   MiscTTT5;                   { Miscellaneous Routines }

TYPE
   strarray = array[1..15] of string;

VAR
   infield  : strarray;
   prattr   : byte;           { Screen attribute for prompts}

PROCEDURE Display_Input_Screen;
BEGIN
   FastWrite(1,1,prattr,'ͻ');
   FastWrite(1,2,prattr,'  Ver.1.0                     Accounts Payable                               ');
   FastWrite(1,3,prattr,'                        (C)1990 by SL-EASY Software                          ');
   FastWrite(1,4,prattr,'͹');
   FastWrite(1,5,prattr,' Vendor No.  :         Name:                                                 ');
   FastWrite(1,6,prattr,' Address     :                                                               ');
   FastWrite(1,7,prattr,' City        :                      State:   Zip:                            ');
   FastWrite(1,8,prattr,' Phone       :               Contact:                                        ');
   FastWrite(1,9,prattr,'͹');
   FastWrite(1,10,prattr,' Comments:                                                                   ');
   FastWrite(1,11,prattr,' :                                                                           ');
   FastWrite(1,12,prattr,' :                                                                           ');
   FastWrite(1,13,prattr,' :                                                                           ');
   FastWrite(1,14,prattr,' :                                                                           ');
   FastWrite(1,15,prattr,' :                                                                           ');
   FastWrite(1,16,prattr,' :                                                                           ');
   FastWrite(1,17,prattr,'                                                                             ');
   FastWrite(1,18,prattr,'͹');
   FastWrite(1,19,prattr,' Use Up,Down arrow or CTRL-Left,CTRL-Right arrow to move to next field.      ');
   FastWrite(1,20,prattr,' Press F10 when done *************************                               ');
   FastWrite(1,21,prattr,'                                                                             ');
   FastWrite(1,22,prattr,'ͼ');
   FastWrite(1,23,prattr,'');
   FastWrite(1,24,prattr,'');
   Create_Fields(15);
   Add_Field(1,0,2,0,2,16,5);
   String_Field(1,InField[1],'######');
   Add_Field(2,1,3,1,3,30,5);
   String_Field(2,InField[2],'***********************************************');
   Add_Field(3,2,4,2,4,16,6);
   String_Field(3,InField[3],'********************************');
   Add_Field(4,3,5,3,5,16,7);
   String_Field(4,InField[4],'*********************');
   Add_Field(5,4,6,4,6,44,7);
   String_Field(5,InField[5],'!!');
   Add_Field(6,5,7,5,7,51,7);
   String_Field(6,InField[6],'#####-####');
   Add_Field(7,6,8,6,8,16,8);
   String_Field(7,InField[7],'(###)###-####');
   Add_Field(8,7,9,7,9,39,8);
   String_Field(8,InField[8],'**************************************');
   Add_Field(9,8,10,8,10,12,10);
   String_Field(9,InField[9],'');
   Add_Field(10,9,11,9,11,4,11);
   String_Field(10,InField[10],'**************************************************************************');
   Add_Field(11,10,12,10,12,4,12);
   String_Field(11,InField[11],'**************************************************************************');
   Add_Field(12,11,13,11,13,4,13);
   String_Field(12,InField[12],'**************************************************************************');
   Add_Field(13,12,14,12,14,4,14);
   String_Field(13,InField[13],'**************************************************************************');
   Add_Field(14,13,15,13,15,4,15);
   String_Field(14,InField[14],'**************************************************************************');
   Add_Field(15,14,16,14,16,4,16);
   String_Field(15,InField[15],'**************************************************************************');
   Display_All_Fields;          { call to IoTTT5 }
END;

PROCEDURE Reset_Fields;
  { Blanks out InField array for clean input screen }
  VAR a : byte;
BEGIN
  for A := 1 to 15 do
     InField[A] := '';
END;   { End of Reset_Fields }

  { *******************  MAIN PROGRAM ******************* }
BEGIN
  Prattr := 7;                     { Color of Prompts }
  Reset_Fields;                    { Blank out fields }
  Display_Input_Screen;
  Process_Input(1);                { Begin input procedure }
      { PUT YOUR PROGRAM HERE  }
END.
