/* ************************************************************************* */
/*                                                                           */
/*                 D O O R W A R E   I / O   L I B R A R Y                   */
/*                                                                           */
/*                          For Mycrosoft & Turbo C                          */
/*                                                                           */
/* ************************************************************************* */
/*                                                                           */
/*      This module contains equates to control the compilation of the       */
/*      DM library.                                                          */
/*                                                                           */
/*                                                                           */
/*                                                                           */
/*                                                                           */
/*                                                                           */
/* ************************************************************************* */



/* ************************************************************************* */
/*                            PROGRAM HISTORY                                */
/* ************************************************************************* */
/* 06/20/87     Version 1.00                                                 */
/* 01/01/90     Version 3.00                                                 */
/*                                                                           */
/*                                                                           */
/*                                                                           */
/* ************************************************************************* */



/*
 * Define Compiler in use
 */

#define MSC             1                       /* Microsoft C               */
#define BTC             2                       /* Boreland Turbo C          */

#define COMPILER        MSC



/*
 * Standard Includes
 */

#if COMPILER == MSC

#include <stdio.h>                              /* standard header file      */
#include <stdlib.h>                             /* standard library interface */
#include <stdarg.h>                             /* standard library interface */
#include <string.h>                             /* string functions          */
#include <conio.h>                              /* keyboard functions        */
#include <fcntl.h>                              /* file control definitions  */
#include <types.h>                              /* type definitions          */
#include <stat.h>                               /* stat definitions          */
#include <share.h>                              /* file sharing definitions  */
#include <io.h>                                 /* file i/o definitions      */
#include <dos.h>                                /* dos functions             */
#include <errno.h>                              /* error definitions         */
#include <memory.h>                             /* memory functions          */
#include <process.h>                            /* process functions         */
#include <time.h>                               /* time functions            */

#endif



#if COMPILER == BTC

#include <stdio.h>                              /* standard header file      */
#include <stdlib.h>                             /* standard library interface */
#include <stdarg.h>                             /* standard library interface */
#include <string.h>                             /* string functions          */
#include <conio.h>                              /* keyboard functions        */
#include <fcntl.h>                              /* file control definitions  */
#include <sys\types.h>                          /* type definitions          */
#include <sys\stat.h>                           /* stat definitions          */
#include <share.h>                              /* file sharing definitions  */
#include <io.h>                                 /* file i/o definitions      */
#include <dos.h>                                /* dos functions             */
#include <errno.h>                              /* error definitions         */
#include <mem.h>                                /* memory functions          */
#include <process.h>                            /* process functions         */
#include <time.h>                               /* time functions            */

#endif





