' ANSI COLOR SUPPORT MODULE for Easy-Door V2.0b
'
' This module includes all the code to use ANSI escape sequence
' in your program without pain. If user do not have ANSI, variables
' will be set to an empty string ("").

' Example:
'
' CALL SendCR(Bright$ + Yellow$ + "Welcome to this DOOR!")
'
' Important: If you use too much color in your program, the display will be
'            slow and, of course, not acceptable for the user.
'            Five characters are needed to send a simple ANSI color code.

IF AnsiFlag$ > "0" THEN

AnsiReset$ = "[0m"          ' Put all mode to off, reset
Blink$ = "[5m"              ' Put in blinking mode
Invert$ = "[7m"             ' Put in reverse video mode
Bright$ = "[1m"             ' Put in high intensity mode (bright)
Down$ ="[1B"                ' Cursor one line down
Up$ = "[1A"                 ' Cursor one line up
SavePos$ = "[s"             ' Save current cursor position
RestorePos$ = "[u"          ' Restore cursor position
AnsiCLS$ = "[2J"            ' ANSI Clear screen sequence
EraseLine$ = "[K"           ' Erase current line

Black$ = "[30m"             '
Red$ = "[31m"               '
Green$ = "[32m"             '
Yellow$ = "[33m"            ' Foreground text color
Blue$ = "[34m"              '
Magenta$ = "[35m"           '
Cyan$ = "[36m"              '
White$ = "[37m"             '

BlackBack$ = "[40m"         '
RedBack$ = "[41m"           '
GreenBack$ = "[42m"         '
YellowBack$ = "[44m"        ' Background text color
BlueBack$ = "[44m"          '
MagentaBack$ = "[45m"       '
CyanBack$ = "[46m"          '
WhiteBack$ = "[47m"         '

END IF
