/* LINEED.H file*/

#include "sys/types.h"
#include "sys/stat.h"
#include "mem.h"
#include "errno.h"
#include "io.h"
#include "fcntl.h"
#include "dos.h"
#include "dir.h"
#include "stdio.h"
#include "string.h"
#include "stdlib.h"
#include "ctype.h"
#include "time.h"
#include "stddef.h"
#include "process.h"
#include "share.h"
#include "alloc.h"
#include "stdarg.h"
#include "conio.h"
#include "setjmp.h"


#define BACKSPACE    "\b \b"

typedef unsigned int  bit;
typedef unsigned int  word;
typedef unsigned char byte;
typedef unsigned long ulong;

/*=====================================================================*/
/* FOSSIL definitions                                                  */
/*=====================================================================*/

#define SETBAUD    0
#define TRANSWAIT  1
#define RECVWAIT   2
#define GETSTAT    3
#define INIT       4
#define DEINIT     5
#define DTR        6
  #define UP         1
  #define DOWN       0
#define FLUSHOUT   8
#define PURGEOUT   9
#define PURGEIN    10
#define TRANSMIT   11
#define PEEK       12
#define KEYNOWAIT  13
#define KEYWAIT    14
#define FLOW       15
#define ONOFF      16
  #define ON         0
  #define OFF        2
#define SETCRSR    17
#define READCRSR   18
#define ONEANSI    19
  #define CARRIER    128
  #define INITOK     0x1954
#define WATCHDOG   20
#define REBOOT     23
  #define COLD       0
  #define WARM       1
#define BLOCKREAD  24
#define BLOCKWRITE 25


/* Symbols for SPAWNIT */

#define SPAWN 0;
#define EXEC  1;
#define BATCH 2;
#define DOS   3;
#define EXIT  4;
#define PRINT 5;

/* Symbols for GENIN */

#define ALLL     1
#define ALPHA    2
#define NUM      3
#define ALPHANUM 4
#define YESNO    5
#define FLE      6
#define FLEP     7
#define FLEW     8
#define FLEPW    9
#define NAME     10
#define NEAT     11
#define PHONE    12
#define DATE     13
#define SUBJECT  14
#define YESNOM   15
#define FLEX     16
#define ARROWS   17
#define ANSIIN   18
#define ANSISET  19
#define FBATCH   20
#define FBATCHW  21
#define FBATCHWP 22
#define FBATCHP  23
#define TRUEANSI 24
#define WORD 	 25
#define WORDNUM	 26
#define BITS     27
#define ANY		 28
#define ANYNOECHO 29
#define HYPER    30
#define THRU     31
#define FLENX    64
#define YESNOQ   65

/* ANSI COLOR TRANS TABLE TO textcolor() */

/* char ansii[8]={30,34,32,36,31,35,33,37}; */

/* EQUATES for ANSI directions */

#define	UPP		0
#define DOWNN   1
#define FORWARD	2
#define BACK	3

/* END OF FILE: msgg.h */
