procedure page_00;
  var
    x, y: word;

  procedure center(s: string);
    begin
    GotoXY((twidth div 2) - (Length(s) div 2), WhereY);
    Writeln(s)
    end;

  begin
  TextColor(LightGreen);
  Window((twidth div 2) - 16, 3, (twidth div 2) + 17, 8);
  Writeln('               ');
  Writeln('                         ');
  Writeln('                   ');
  Writeln('                         ');
  Writeln('                    ');
  Window(1, 8, twidth, 9);
  TextColor(LightCyan);
  for x:=1 to twidth do
    Write(#220);
  Window(1, 9, (twidth div 2) - 1, tlength - 2);
  TextColor(White);
  Writeln('Page 0  - Table of Contents');
  Writeln('Page 1  - Machine & ROM Identification');
  Writeln('Page 2  - CPU and FPU Identification');
  Writeln('Page 3  - RAM type Identification');
  Writeln('Page 4  - List of Memory Blocks');
  Writeln('Page 5  - Video Identification');
  Writeln('Page 6  - Video Information');
  Writeln('Page 7  - Keyboard & Mouse Information');
  Write('Page 8  - Parallel/Serial Port Info');
  Window((twidth div 2) + 1, 9, twidth, tlength - 2);
  Writeln('Page 9  - DOS Information');
  Writeln('Page 10 - Multiplex Programs');
  Writeln('Page 11 - Environment Variables');
  Writeln('Page 12 - Device Drivers');
  Writeln('Page 13 - DOS Drive Information');
  Writeln('Page 14 - BIOS Drive Information');
  Writeln('Page 15 - Partition Table Listing');
  Writeln('Page 16 - Boot & DOS Drive Parameters');
  Write('Page 17 - Thanks');
  Window(1, 18, twidth, 19);
  TextColor(LightCyan);
  for x:=1 to twidth do
    Write(#220);
  Window(1, 1, twidth, tlength);
  x:=twidth div 2;
  for y:=9 to 18 do
    begin
    GotoXY(x, y);
    Write(#219);
    end;
  Window(1, 19, twidth, tlength - 2);
  TextColor(Yellow);
  Writeln;
  Center('INFOPLUS - ' + qversion);
  Center('by Andrew Rossmann, ' + qdate);
  Center('Released to the Public Domain');
  end;